;--------------------------------

!include "Library.nsh"

; The name of the installer
Name "Example"

; The file to write
OutFile "Example.exe"

; The default installation directory
InstallDir $PROGRAMFILES\Example

; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM "Software\PDF Application" "Install_Dir"

; Request application privileges for Windows Vista
RequestExecutionLevel admin

;--------------------------------

; Pages

Page components
Page directory
Page instfiles

UninstPage uninstConfirm
UninstPage instfiles

;--------------------------------

; The stuff to install
Section "Application"

  SectionIn RO
  
  ; Set output path to the installation directory.
  SetOutPath $INSTDIR

!define DLL '"PDFCreatorPilot.dll"'  

  ; Put file there
  File "PDF Application.exe"
  File PDFCreatorPilot.dll
  
  ; Write the installation path into the registry
   WriteRegStr HKLM SOFTWARE\Example "Install_Dir" "$INSTDIR"

    #PDF library registration information:
   !insertmacro InstallLib REGDLL    NOTSHARED NOREBOOT_PROTECTED    ${DLL} $INSTDIR\PDFCreatorPilot.dll $INSTDIR
  
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example" "UninstallString" '"$INSTDIR\uninstall.exe"'
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example" "NoModify" 1
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example" "NoRepair" 1
  WriteUninstaller "uninstall.exe"
  
SectionEnd

; Optional section (can be disabled by the user)
Section "Start Menu Shortcuts"

  CreateDirectory "$SMPROGRAMS\PDF Application"
  CreateShortCut "$SMPROGRAMS\PDF Application\Uninstall.lnk" "$INSTDIR\uninstall.exe" "" "$INSTDIR\uninstall.exe" 0
  CreateShortCut "$SMPROGRAMS\PDF Application\PDF Application.lnk" "$INSTDIR\PDF Application.exe" "" "$INSTDIR\PDF Application.exe" 0
  


SectionEnd

;--------------------------------

; Uninstaller

Section "Uninstall"
  
  ; Remove registry keys
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Example"
  DeleteRegKey HKLM SOFTWARE\Example

!insertmacro UninstallLib DLL       NOTSHARED NOREBOOT_PROTECTED     $INSTDIR\PDFCreatorPilot.dll

  ; Remove files and uninstaller
  Delete $INSTDIR\PDFCreatorPilot.dll
  Delete $INSTDIR\uninstall.exe

  ; Remove shortcuts, if any
  Delete "$SMPROGRAMS\PDF Application\*.*"

  ; Remove directories used
  RMDir "$SMPROGRAMS\PDF Application"
  RMDir "$INSTDIR"

SectionEnd
